// Use this with Listing 1.3.

[Keyword("application"), Keyword("app"), Keyword("program",Relevance=2)]
public interface IApplication
{
  [Keyword("animated", Relevance=10), Keyword("movie"), Keyword("picture")]
  void EnableAnimations();

  [Keyword("exit"), Keyword("shutdown"), Keyword("close"), Keyword("kill")]
  void Quit();

  [Keyword("title")]
  string Caption { get; set; }

  [Keyword("parent"), Keyword("owner")]
  string Creator { get; set; }
}