' To compile:
' vbc /t:library Listing1_5.vb ExampleAttribute.vb

' Attribute on assembly, placed at the top of a source file
<Assembly:Example>   
' Attribute on module, placed at the top of a source file  
<Module:Example>     

<Example> Public Class Class1 ' Attribute on class
  <Example> Public Sub New() ' Attribute on constructor
  End Sub

  <Example> Public Sub MyMethod1() ' Attribute on method
  End Sub

  Public Sub MyMethod2(<Example> s As String) ' Attribute on parameter
  End Sub

  ' Attribute on return value
  Public Function MyMethod3() As <Example> String
    MyMethod3 = ""
  End Function

  ' Attribute on property and another attribute on
  ' return value for get accessor method
  <Example> Public Property MyProperty As <Example> String 
    Get
      Return ""
    End Get

    ' Attribute on parameter for accessor method
    Set (<Example> Value As String)
    End Set
  End Property
End Class

<Example> Public Structure MyStruct ' Attribute on struct
  <Example> Public MyField As Integer ' Attribute on field
End Structure

' Attribute on delegate
<Example> Public Delegate Function MyDelegate1() as Integer
' Attribute on delegate's return value 
Public Delegate Function MyDelegate2() as <Example> Integer

<Example> Public Enum MyEnum ' Attribute on enum
  One
  Two
End Enum

' Multiple attributes on interface
<Example, Example, Example> Public Interface MyInterface
  <Example> Event MyEvent() ' Attribute on event
End Interface