<%@ Page aspcompat=true %>
<%@ Import namespace="System.Data" %>
<%@ Import namespace="System.Reflection" %>
<script language="C#" runat="server">
void Page_Load(object sender, EventArgs e)
{
  object temp;
  string strConnection;
  int i;
  
  // Connection string for the sample "pubs" database
  strConnection = 
    "DRIVER={SQL Server};SERVER=(local);UID=sa;PWD=;DATABASE=pubs;";
  try
  {
    // Call a method on the page's connection object
    connection.GetType().InvokeMember("Open", BindingFlags.InvokeMethod,
      null, connection, new object []
      {strConnection, Type.Missing, Type.Missing, Type.Missing});
  }
  catch (Exception ex)
  {
    Response.Write("Unable to open connection to database.  " 
      + ex.Message);
  }
  
  try
  {
    // Set properties and call a method on the page's recordset object
    recordset.GetType().InvokeMember("CursorType", 
      BindingFlags.SetProperty, null, recordset, new object [] {1});
    recordset.GetType().InvokeMember("LockType", BindingFlags.SetProperty,
      null, recordset, new object [] {3});
    recordset.GetType().InvokeMember("Open", BindingFlags.InvokeMethod,
      null, recordset, new object []
      {"titles", connection, Type.Missing, Type.Missing, 2});
  }
  catch (Exception ex)
  {
    Response.Write("Unable to open recordset.  " + ex.Message);
  }
  
  DataTable table;
  DataRow row;
  
  // Create a DataTable
  table = new DataTable();
  
  // Get the value of recordset.Fields.Count ahead of time
  temp = recordset.GetType().InvokeMember("Fields", 
    BindingFlags.GetProperty, null, recordset, null);
  int count = (int)temp.GetType().InvokeMember("Count", 
    BindingFlags.GetProperty, null, temp, null);
  
  // Add the appropriate columns
  for (i = 0; i < count; i++)
  {
    temp = recordset.GetType().InvokeMember("Fields",
      BindingFlags.GetProperty, null, recordset, new object [] {i});
    string name = (string) temp.GetType().InvokeMember("Name", 
      BindingFlags.GetProperty, null, temp, null);
    table.Columns.Add(new DataColumn(name, typeof(String)));
  }
  
  // Scan through the recordset and add a row for each record
  while (!(bool)recordset.GetType().InvokeMember("EOF", 
    BindingFlags.GetProperty, null, recordset, null))
  {
    row = table.NewRow();
  
    // Look at each field and add an entry to the row
    for (i = 0; i < count; i++)
    {
      temp = recordset.GetType().InvokeMember("", 
        BindingFlags.GetProperty, null, recordset, new object [] {i});
      row[i] = temp.GetType().InvokeMember("", BindingFlags.GetProperty,
        null, temp, null).ToString();
    }
  
    // Add the row to the DataTable
    table.Rows.Add(row);
  
    recordset.GetType().InvokeMember("MoveNext", 
      BindingFlags.InvokeMethod, null, recordset, null);
  }
 
  // Update the DataGrid control
    dataGrid1.DataSource = new DataView(table);
  dataGrid1.DataBind();
 
  // Cleanup
  recordset.GetType().InvokeMember("Close", BindingFlags.InvokeMethod,
    null, recordset, null);
  connection.GetType().InvokeMember("Close", BindingFlags.InvokeMethod,
    null, connection, null);
}
</script>
 
<html><title>Using ADO in ASP.NET</title>
  <body>
      <form runat=server>
      <asp:DataGrid id="dataGrid1" runat="server"
        BorderColor="black"
        GridLines="Both"
        BackColor="#ffdddd"
      />
    </form>
    <object id="connection" runat="server"
      progid="ADODB.Connection"/>
    <object id="recordset" runat="server"
      progid="ADODB.Recordset"/>
  </body>
</html>
