<%@ Page aspcompat=true %>
<%@ Import namespace="System.Data" %>
<script language="VB" runat="server">
Sub Page_Load(sender As Object, e As EventArgs)
  Dim strConnection As String
  Dim i As Integer

  ' Connection string for the sample "pubs" database
  strConnection = _ 
    "DRIVER={SQL Server};SERVER=(local);UID=sa;PWD=;DATABASE=pubs;"

  Try
    ' Call a method on the page's connection object
    connection.Open(strConnection)
  Catch ex as Exception
    Response.Write("Unable to open connection to database.  " + ex.Message)
  End Try

  Try
    ' Set properties and call a method on the page's recordset object
    recordset.CursorType = 1 ' 1 = ADODB.CursorTypeEnum.adOpenKeyset
    recordset.LockType = 3   ' 3 = ADODB.LockTypeEnum.adLockOptimistic
    ' 2 = ADODB.CommandTypeEnum.adCmdTable
    recordset.Open("titles", connection, , , 2) 
  Catch ex as Exception
    Response.Write("Unable to open recordset.  " + ex.Message)
  End Try

  Dim table As DataTable
  Dim row As DataRow

  ' Create a DataTable
  table = New DataTable()

  ' Add the appropriate columns
  For i = 0 to recordset.Fields.Count - 1
    table.Columns.Add(New DataColumn(recordset.Fields(i).Name, _
      GetType(String)))
  Next

  ' Scan through the recordset and add a row for each record
  Do While Not recordset.EOF
    row = table.NewRow()

    ' Look at each field and add an entry to the row
    For i = 0 to recordset.Fields.Count - 1
      row(i) = recordset.Fields(i).Value.ToString()
    Next

    ' Add the row to the DataTable
    table.Rows.Add(row)

    recordset.MoveNext()
  Loop

  ' Update the DataGrid control
  dataGrid1.DataSource = New DataView(table)
  dataGrid1.DataBind()

  ' Cleanup
  recordset.Close()
  connection.Close()
End Sub
</script>

<html><title>Using ADO in ASP.NET</title>
  <body>
    <form runat=server>
      <asp:DataGrid id="dataGrid1" runat="server"
        BorderColor="black"
        GridLines="Both"
        BackColor="#ffdddd"
      />
    </form>
    <object id="connection" runat="server"
      progid="ADODB.Connection"/>
    <object id="recordset" runat="server"
      progid="ADODB.Recordset"/>
  </body>
</html>