' To compile:
' vbc Listing5_5.vb /r:System.Windows.Forms.dll

Imports System

Public Class Display
  Public Sub ConsoleMessage(ByVal text As String)
    Console.WriteLine("MESSAGE: " & text)
  End Sub

  Public Sub AnnoyingMessage(ByVal text As String)
    System.Windows.Forms.MessageBox.Show("MESSAGE: " & text)
  End Sub
End Class

Module ChatRoomClient
  Sub Main()
    Dim display As New Display()
    Dim server As New ChatRoomServer()
    AddHandler server.DisplayMessage, AddressOf display.ConsoleMessage
    AddHandler server.DisplayMessage, AddressOf display.AnnoyingMessage
    '...
    server.Run()
    '...
    RemoveHandler server.DisplayMessage, AddressOf display.ConsoleMessage
    RemoveHandler server.DisplayMessage, AddressOf display.AnnoyingMessage
  End Sub
End Module

Public Class ChatRoomServer
  Public Event DisplayMessage(ByVal text As String)
  Public Event UserJoined(ByVal user As String)
  Public Event UserLeft(ByVal user As String)

  Public Sub Run()
    '...
    ' The callback
    RaiseEvent DisplayMessage("text")
    '...
  End Sub
End Class