// To compile, first obtain an Interop Assembly for PowerPoint 2002.  If a PIA is not yet
// available, run TLBIMP on msppt.olb.  Then run:
// csc PowerPointSnippet3cs.cs /r:PowerPoint.dll /r:Office.dll

using System;
using PowerPoint;
using Microsoft.Office.Core;

public class Client
{
  public static void Main()
  {
    Application app = new Application();
    Presentations pres = app.Presentations;
    app.Visible = MsoTriState.msoTrue;
    app.Quit();

    // This causes the PowerPoint application to exit:
    System.Runtime.InteropServices.Marshal.ReleaseComObject(pres);

    Console.WriteLine("Press Enter to exit...");
    Console.ReadLine();
  }
}