// To compile, first obtain an Interop Assembly for PowerPoint 2002.  If a PIA is not yet
// available, run TLBIMP on msppt.olb.  Then run:
// csc PowerPointSnippet4cs.cs /r:PowerPoint.dll /r:Office.dll

using System;
using PowerPoint;
using Microsoft.Office.Core;

public class Client
{
  public static void Main()
  {
    Application app = new Application();
    Presentations pres = app.Presentations;
    app.Visible = MsoTriState.msoTrue;
    app.Quit();

    // Attempt to collect the pres instance
    GC.Collect();
    GC.WaitForPendingFinalizers();

    Console.WriteLine("Press Enter to exit...");
    Console.ReadLine();
  }
}