// To compile:
// csc /t:library IdlCustomAttribute.cs

using System;

[AttributeUsage(AttributeTargets.All)]
public class IdlCustomAttribute : Attribute
{
  private object value;
  private Guid guid;

  public IdlCustomAttribute(Guid guid, object value)
  {
    this.guid = guid;
    this.value = value;
  }

  public object Value { get { return value; } }
  public Guid Name { get { return guid; } }
}