// To compile, do the following on a computer with Office XP,
// adjusting the path as appropriate:
//
// 1. tlbimp "c:\Program Files\Microsoft Office\Office10\MSWORD.OLB"
// 2. ildasm Word.dll /out=Word.il
// 3. Make the changes to Word.il described in Chapter 7.
// 4. ilasm /dll Word.il
// 5. csc Listing7_4modifiedcs.cs /r:Word.dll

using System;

public class UseWord
{
  public static bool FAILED(int hr)
  {
    return (hr < 0);
  }

  public static void Main()
  {
    object missing = Type.Missing;
    Word.Application msWord = null;
    try
    {
      msWord = new Word.Application();
    }
    catch (Exception ex)
    {
      Console.WriteLine("Unexpected error: " + ex.ToString());
      return;
    }

    int hr = 0; // S_OK
    Word._Document doc;

    hr = msWord.Documents.Add(ref missing, ref missing, ref missing,
      ref missing, out doc);
    if (FAILED(hr))
    {
      Console.WriteLine("Unexpected error: 0x" + hr);
      return;
    }

    try
    {
      Console.WriteLine("Added the document '" + doc.FullName + "'.");
    }
    catch (Exception ex)
    {
      Console.WriteLine("Unexpected error: " + ex.ToString());
      return;
    }

    hr = msWord.Quit(ref missing, ref missing, ref missing);
    if (FAILED(hr))
      Console.WriteLine("Unexpected error: 0x" + hr);
  }
}