' To compile, do the following on a computer with Office XP,
' adjusting the path as appropriate:
'
' 1. tlbimp "c:\Program Files\Microsoft Office\Office10\MSWORD.OLB"
' 2. ildasm Word.dll /out=Word.il
' 3. Make the changes to Word.il described in Chapter 7.
' 4. ilasm /dll Word.il
' 5. vbc Listing7_4modifiedvb.vb /r:Word.dll

Imports System

Public Class UseWord
   
  Public Shared Function FAILED(hr As Integer) As Boolean
    FAILED = hr < 0
  End Function
   
  Public Shared Sub Main()
    Dim missing As Object = Type.Missing
    Dim msWord As Word.Application = Nothing
    Try
      msWord = New Word.Application()
    Catch ex As Exception
      Console.WriteLine("Unexpected error: " & ex.ToString())
      Exit Sub
    End Try
      
    Dim hr As Integer = 0 ' S_OK
    Dim doc As Word._Document
      
    hr = msWord.Documents.Add(missing, missing, missing, missing, doc)
    If FAILED(hr) Then
      Console.WriteLine("Unexpected error: 0x" & hr)
      Exit Sub
    End If
      
    Try
      Console.WriteLine("Added the document '" & doc.FullName & "'.")
    Catch ex As Exception
      Console.WriteLine("Unexpected error: " & ex.ToString())
      Exit Sub
    End Try
      
    hr = CType(msWord, Word._Application).Quit(missing, missing, missing)
    If FAILED(hr) Then
      Console.WriteLine(("Unexpected error: 0x" + hr))
    End If
  End Sub
End Class