' To compile:
' vbc /t:library LabeledTextBox.vb /r:System.Windows.Forms.dll /r:System.Drawing.dll /r:System.dll

' Note: To run this code from the Internet zone, make sure your computer's security policy allows it.

Imports System.Windows.Forms
Imports System.Security

<Assembly:AllowPartiallyTrustedCallersAttribute>

Public Class LabeledTextBox
  Inherits UserControl

  Private textBox1 As System.Windows.Forms.TextBox
  Private label1 As System.Windows.Forms.Label
  Private components As System.ComponentModel.Container = Nothing

  Public Sub New()
    ' This call is required by the Windows.Forms Form Designer
    InitializeComponent()
  End Sub
   
  Public Property LabelText() As String
    Get
      Return label1.Text
    End Get
    Set
      label1.Text = value
    End Set
  End Property 

  Public Property TextBoxText() As String
    Get
      Return textBox1.Text
    End Get
    Set
      textBox1.Text = value
    End Set
  End Property

  ' Clean up any resources being used
  Protected Overrides Overloads Sub Dispose(disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  ' Required method for Designer support
  Private Sub InitializeComponent()
    Me.textBox1 = New System.Windows.Forms.TextBox()
    Me.label1 = New System.Windows.Forms.Label()
    Me.SuspendLayout()

    Me.textBox1.Anchor = System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Right
    Me.textBox1.Location = New System.Drawing.Point(112, 0)
    Me.textBox1.Multiline = True
    Me.textBox1.Name = "textBox1"
    Me.textBox1.Size = New System.Drawing.Size(144, 20)
    Me.textBox1.TabIndex = 0
    Me.textBox1.Text = "TextBox"

    Me.label1.Anchor = System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right
    Me.label1.Name = "label1"
    Me.label1.Size = New System.Drawing.Size(112, 20)
    Me.label1.TabIndex = 1
    Me.label1.Text = "Label"
    Me.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight

    Me.Controls.AddRange(New System.Windows.Forms.Control(){Me.label1, Me.textBox1})
    Me.Name = "LabeledTextBox"
    Me.Size = New System.Drawing.Size(256, 20)
    Me.ResumeLayout(False)
  End Sub

End Class