' To compile:
' vbc /t:library StringValidator.vb /r:System.dll

Imports System.Text.RegularExpressions
Imports System.Reflection

<Assembly:AssemblyKeyFile("KeyFile.snk")>

Public Class StringValidator

  Public Function IsPhoneNumber(s As String) As Boolean
    IsPhoneNumber = Regex.IsMatch(s, _
      "^(((\(\d{3}\)( )?)|(\d{3}( |\-)))\d{3}\-\d{4})$")
  End Function

  Public Function IsZipCode(s As String) As Boolean
    IsZipCode = Regex.IsMatch(s, "^((\d{5})|(\d{5}\-\d{4}))$")
  End Function

  Public Function IsSSN(s As String) As Boolean
    IsSSN = Regex.IsMatch(s, "^\d{3}\-\d{2}\-\d{4}$")
  End Function

End Class