Attribute VB_Name = "Module1"
Public Sub Main()
  Dim host As CorRuntimeHost
  Dim domain As AppDomain

  ' Initialize the CLR
  Set host = New CorRuntimeHost
  host.Start
  host.GetDefaultDomain domain

  ' Create an instance in the default domain
  Dim sl As SortedList
  Set sl = _
    domain.CreateInstance("mscorlib", "System.Collections.SortedList").Unwrap
 
  ' Use it normally
  sl.Add "Advanced", "Advanced"
  sl.Add "Topics", "Topics"
  sl.Add "for", "for"
  sl.Add "Using", "Using"
  sl.Add ".NET", ".NET"
  sl.Add "Components", "Components"

  Dim list As IEnumerable
  Set list = sl.GetValueList

  ' Enumerate through the sorted list of values
  Dim s As String
  Dim v As Variant
  For Each v In list
    s = s + v + " "
  Next
  MsgBox s
  host.Stop
End Sub
