// To compile:
// csc /t:library Listing10_6cs.cs

using System.Runtime.InteropServices;

// Interface inheritance

[ComVisible(false)]
public interface IAmInvisibleToCom
{
  void SomeMethod();
}

public interface IAmVisibleToAll : IAmInvisibleToCom
{
}

// Class inheritance

[ComVisible(false)]
public class ClassForManagedEyesOnly
{
  public void SomeMethod() {}
}

// Expose type information for the class interface
// so we can see what members it contains
[ClassInterface(ClassInterfaceType.AutoDual)]
public class ClassVisibleToAll : ClassForManagedEyesOnly
{
}