' To compile:
' vbc /t:library ClassWithCustomRegistration.vb

Imports System
Imports System.Runtime.InteropServices

Public Class ClassWithCustomRegistration
  <ComRegisterFunction> _
  Private Shared Sub RegisterFunction(t As Type)
    ' Add a custom key to the registry
    Dim key As Microsoft.Win32.RegistryKey
    key = Microsoft.Win32.Registry.ClassesRoot.CreateSubKey( _
      "CLSID\" & t.GUID.ToString("B") & "\Implemented Categories\" _
      & "{00021493-0000-0000-C000-000000000046}")
    key.Close()
  End Sub
    
  <ComUnregisterFunction> _
  Private Shared Sub UnregisterFunction(t As Type)
    ' Undo the work from the registration function
    Microsoft.Win32.Registry.ClassesRoot.DeleteSubKey( _
      "CLSID\" & t.GUID.ToString("B") & "\Implemented Categories\" _
      & "{00021493-0000-0000-C000-000000000046}", False)
  End Sub
End Class