' This is incorrect code, just for demonstration.
' MarshalAsAttribute should be used consistently, and auto-dual class interfaces should be avoided.

' To compile:
' vbc /t:library Listing12_1vb.vb

Imports System
Imports System.Runtime.InteropServices

<Assembly: ClassInterface(ClassInterfaceType.AutoDual)>

Public Interface IDonate
  Sub GiveMoney(<MarshalAs(UnmanagedType.Currency)> amount As Decimal)
End Interface

Public Class Philanthropist
  Implements IDonate
   
  ' UnmanagedType.Currency is omitted for demonstration
  Public Overridable Sub GiveMoney(amount As Decimal) Implements IDonate.GiveMoney
  End Sub
End Class

Public Class Humanitarian
  Inherits Philanthropist
   
  Public Overrides Sub GiveMoney(<MarshalAs(UnmanagedType.Currency)> amount As Decimal)
  End Sub
End Class