// To compile:
// csc /t:library Listing12_7.cs

using System.Runtime.InteropServices;
using System.Reflection;

// Generate dual interfaces so we can see what is exposed to COM
[assembly:ClassInterface(ClassInterfaceType.AutoDual)]

public class C1
{
  // A regular C# indexer
  public int this[int i]
  {
    get { return 0; }
  }
}

[DefaultMember("Item")]
public class C2
{
  // A plain default property
  public int Item
  {
    get { return 0; }
  }
}

[DefaultMember("Item")]
public class C3
{
  // A default method
  [DispId(0)]
  public int Item() { return 0; }
}