// To compile:
// csc /t:library Listing12_8cs.cs

using System.Runtime.InteropServices;

public class C
{
  public void ReturnSFalseBad()
  {
    // Throwing an exception should be reserved for failure due
    // to the overhead of exception handling
    throw new COMException("Success Result", 1);
  }

  [return:MarshalAs(UnmanagedType.Error)]
  [PreserveSig]
  public int ReturnSFalseGood()
  {
    // Returning an integer is much faster than throwing an exception
    return 1;
  }
}