VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form ClientForm 
   Caption         =   "COM Event Sink"
   ClientHeight    =   4860
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   5340
   LinkTopic       =   "Form1"
   ScaleHeight     =   4860
   ScaleWidth      =   5340
   StartUpPosition =   3  'Windows Default
   Begin MSComctlLib.TreeView TreeView1 
      Height          =   2535
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   3615
      _ExtentX        =   6376
      _ExtentY        =   4471
      _Version        =   393217
      LabelEdit       =   1
      LineStyle       =   1
      Style           =   7
      Appearance      =   1
   End
End
Attribute VB_Name = "ClientForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' To compile this, first compile
' ComFriendlyForm.cs or ComFriendlyForm.vb.
' Then export a type library from ComFriendlyForm.dll
' and reference it from this project.

' Besides ComFriendlyForm.tlb, you must reference
' mscorlib.tlb, System.tlb, and System.Windows.Forms.tlb.

Option Explicit
Private WithEvents windowsForm As ComFriendlyForm.ComFriendlyForm
Attribute windowsForm.VB_VarHelpID = -1

Private Sub Form_Load()
  Set windowsForm = New ComFriendlyForm.ComFriendlyForm
  windowsForm.Show
End Sub

Private Sub Form_Resize()
  TreeView1.width = ScaleWidth
  TreeView1.height = ScaleHeight
End Sub

' Add an event notification to the TreeView. If this is the first
' time the event has been raised, create a new node for it.
Private Sub AddMessage(node As String, message As String)
  On Error GoTo CreateNode
  TreeView1.Nodes.Add node, tvwChild, , message
  Exit Sub
CreateNode:
  TreeView1.Nodes.Add , , node, node
  TreeView1.Nodes.Add node, tvwChild, , message
End Sub

Private Sub windowsForm_Activated(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Activated", Time
End Sub

Private Sub windowsForm_BackColorChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "BackColorChanged", Time
End Sub

Private Sub windowsForm_BackgroundImageChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "BackgroundImageChanged", Time
End Sub

Private Sub windowsForm_BindingContextChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "BindingContextChanged", Time
End Sub

Private Sub windowsForm_CausesValidationChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "CausesValidationChanged", Time
End Sub

Private Sub windowsForm_ChangeUICues(ByVal sender As Variant, _
ByVal changeFocus As Boolean, ByVal changeKeyboard As Boolean, _
ByVal showFocus As Boolean, ByVal showKeyboard As Boolean)
  AddMessage "ChangeUICues", Time & ", ChangeFocus = " & changeFocus & _
  ", ChangeKeyboard = " & changeKeyboard & ", ShowFocus = " & showFocus & _
  ", ShowKeyboard = " & showKeyboard
End Sub

Private Sub windowsForm_Click(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Click", Time
End Sub

Private Sub windowsForm_Closed(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Closed", Time
End Sub

Private Sub windowsForm_Closing(ByVal sender As Variant, cancel As Boolean)
  AddMessage "Closing", Time
End Sub

Private Sub windowsForm_ContextMenuChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "ContextMenuChanged", Time
End Sub

Private Sub windowsForm_ControlAdded(ByVal sender As Variant, _
ByVal control As System.IComponent)
  AddMessage "ControlAdded", Time & ", Site Name = " & control.Site.Name
End Sub

Private Sub windowsForm_ControlRemoved(ByVal sender As Variant, _
ByVal control As System.IComponent)
  AddMessage "ControlRemoved", Time & ", Site Name = " & control.Site.Name
End Sub

Private Sub windowsForm_CursorChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "CursorChanged", Time
End Sub

Private Sub windowsForm_Deactivate(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Deactivate", Time
End Sub

Private Sub windowsForm_Disposed(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Disposed", Time
End Sub

Private Sub windowsForm_DockChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "DockChanged", Time
End Sub

Private Sub windowsForm_DoubleClick(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "DoubleClick", Time
End Sub

Private Sub windowsForm_DragDrop(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.DragEventArgs)
  ' Late bind to members of DragEventArgs
  Dim o As Object
  Set o = e
  AddMessage "DragDrop", Time & ", x = " & o.x & ", y = " & o.y & _
    ", KeyState = " & o.KeyState
End Sub

Private Sub windowsForm_DragEnter(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.DragEventArgs)
  ' Late bind to members of DragEventArgs
  Dim o As Object
  Set o = e
  AddMessage "DragEnter", Time & ", x = " & o.x & ", y = " & o.y & _
    ", KeyState = " & o.KeyState
End Sub

Private Sub windowsForm_DragLeave(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "DragLeave", Time
End Sub

Private Sub windowsForm_DragOver(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.DragEventArgs)
  ' Late bind to members of DragEventArgs
  Dim o As Object
  Set o = e
  AddMessage "DragOver", Time & ", x = " & o.x & ", y = " & o.y & _
    ", KeyState = " & o.KeyState
End Sub

Private Sub windowsForm_EnabledChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "EnabledChanged", Time
End Sub

Private Sub windowsForm_Enter(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Enter", Time
End Sub

Private Sub windowsForm_FontChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "FontChanged", Time
End Sub

Private Sub windowsForm_ForeColorChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "ForeColorChanged", Time
End Sub

Private Sub windowsForm_GiveFeedback(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.GiveFeedbackEventArgs)
  ' Late bind to members of GiveFeedbackEventArgs
  Dim o As Object
  Set o = e
  AddMessage "GiveFeedback", Time & ", Effect = " & o.Effect & _
    ", UseDefaultCursors = " & o.UseDefaultCursors
End Sub

Private Sub windowsForm_GotFocus(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "GotFocus", Time
End Sub

Private Sub windowsForm_HandleCreated(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "HandleCreated", Time
End Sub

Private Sub windowsForm_HandleDestroyed(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "HandleDestroyed", Time
End Sub

Private Sub windowsForm_HelpRequested(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.HelpEventArgs)
  ' Late bind to HelpEventArgs.Handled.
  ' We can't access HelpEventArgs.MousePos property
  ' directly since it's a COM-invisible value type
  Dim o As Object
  Set o = e
  AddMessage "HelpRequested", Time & ", Handled = " & o.Handled
End Sub

Private Sub windowsForm_ImeModeChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "ImeModeChanged", Time
End Sub

Private Sub windowsForm_InputLanguageChanged(ByVal sender As Variant, _
ByVal charSet As Byte, ByVal culture As mscorlib.CultureInfo, _
ByVal inputLanguageHandle As Long, ByVal inputLanguageLayoutName As String)
  ' Late bind to some members of CultureInfo
  Dim o As Object
  Set o = culture
  AddMessage "InputLanguageChanged", Time & ", Char Set = " & charSet & _
    ", Culture Display Name = " & o.DisplayName & ", Culture LCID = " & _
    o.LCID & ", Input Language Handle = " & inputLanguageHandle & _
    ", Input Language Layout Name = " & inputLanguageLayoutName
End Sub

Private Sub windowsForm_InputLanguageChanging(ByVal sender As Variant, _
cancel As Boolean, ByVal sysCharSet As Boolean, _
ByVal culture As mscorlib.CultureInfo, ByVal inputLanguageHandle As Long, _
ByVal inputLanguageLayoutName As String)
  ' Late bind to some members of CultureInfo
  Dim o As Object
  Set o = culture
  AddMessage "InputLanguageChanging", Time & ", System Char Set = " & _
    sysCharSet & ", Culture Display Name = " & o.DisplayName & _
    ", Culture LCID = " & o.LCID & ", Input Language Handle = " & _
    inputLanguageHandle & ", Input Language Layout Name = " & _
    inputLanguageLayoutName
End Sub

Private Sub windowsForm_Invalidated(ByVal sender As Variant, _
ByVal x As Long, ByVal y As Long, ByVal width As Long, _
ByVal height As Long)
  AddMessage "Invalidated", Time & ", x = " & x & ", y = " & y & _
    ", width = " & width & ", height = " & height
End Sub

Private Sub windowsForm_KeyDown(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.KeyEventArgs)
  ' Late bind to members of KeyEventArgs
  Dim o As Object
  Set o = e
  AddMessage "KeyDown", Time & ", Alt = " & o.Alt & ", Control = " & _
    o.control & ", Shift = " & o.Shift & ", KeyValue = " & o.KeyValue
End Sub

Private Sub windowsForm_KeyPress(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.KeyPressEventArgs)
  ' Late bind to KeyPressEventArgs.KeyChar
  Dim o As Object
  Set o = e
  AddMessage "KeyPress", Time & ", KeyChar = " & o.KeyChar
End Sub

Private Sub windowsForm_KeyUp(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.KeyEventArgs)
  ' Late bind to members of KeyEventArgs
  Dim o As Object
  Set o = e
  AddMessage "KeyUp", Time & ", Alt = " & o.Alt & ", Control = " & _
    o.control & ", Shift = " & o.Shift & ", KeyValue = " & o.KeyValue
End Sub

Private Sub windowsForm_Layout(ByVal sender As Variant, _
ByVal affectedControl As System.IComponent, _
ByVal affectedProperty As String)
  AddMessage "Closing", Time & ", Affected Property = " & affectedProperty
End Sub

Private Sub windowsForm_Leave(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Leave", Time
End Sub

Private Sub windowsForm_Load(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Load", Time
End Sub

Private Sub windowsForm_LocationChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "LocationChanged", Time
End Sub

Private Sub windowsForm_LostFocus(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "LostFocus", Time
End Sub

Private Sub windowsForm_MaximizedBoundsChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "MaximizedBoundsChanged", Time
End Sub

Private Sub windowsForm_MaximumSizeChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "MaximumSizeChanged", Time
End Sub

Private Sub windowsForm_MdiChildActivate(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "MdiChildActivate", Time
End Sub

Private Sub windowsForm_MenuComplete(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "MenuComplete", Time
End Sub

Private Sub windowsForm_MenuStart(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "MenuStart", Time
End Sub

Private Sub windowsForm_MinimumSizeChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "MinimumSizeChanged", Time
End Sub

Private Sub windowsForm_MouseDown(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.MouseEventArgs)
  ' Late bind to members of MouseEventArgs
  Dim o As Object
  Set o = e
  AddMessage "MouseDown", Time & ", x = " & o.x & ", y = " & o.y & _
    ", Clicks = " & o.Clicks & ", Delta = " & o.Delta & ", Button = " & _
    o.Button
End Sub

Private Sub windowsForm_MouseEnter(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "MouseEnter", Time
End Sub

Private Sub windowsForm_MouseHover(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "MouseHover", Time
End Sub

Private Sub windowsForm_MouseLeave(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "MouseLeave", Time
End Sub

Private Sub windowsForm_MouseMove(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.MouseEventArgs)
  ' Late bind to members of MouseEventArgs
  Dim o As Object
  Set o = e
  AddMessage "MouseMove", Time & ", x = " & o.x & ", y = " & o.y & _
    ", Clicks = " & o.Clicks & ", Delta = " & o.Delta & ", Button = " & _
    o.Button
End Sub

Private Sub windowsForm_MouseUp(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.MouseEventArgs)
  ' Late bind to members of MouseEventArgs
  Dim o As Object
  Set o = e
  AddMessage "MouseUp", Time & ", x = " & o.x & ", y = " & o.y & _
    ", Clicks = " & o.Clicks & ", Delta = " & o.Delta & ", Button = " & _
    o.Button
End Sub

Private Sub windowsForm_MouseWheel(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.MouseEventArgs)
  ' Late bind to members of MouseEventArgs
  Dim o As Object
  Set o = e
  AddMessage "MouseWheel", Time & ", x = " & o.x & ", y = " & o.y & _
    ", Clicks = " & o.Clicks & ", Delta = " & o.Delta & ", Button = " & _
    o.Button
End Sub

Private Sub windowsForm_Move(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Move", Time
End Sub

Private Sub windowsForm_Paint(ByVal sender As Variant, _
ByVal hdc As Long, ByVal x As Long, ByVal y As Long, _
ByVal width As Long, ByVal height As Long)
  AddMessage "Paint", Time & ", HDC = " & hdc & ", x = " & x & ", y = " & _
  y & ", width = " & width & ", height = " & height
End Sub

Private Sub windowsForm_ParentChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "ParentChanged", Time
End Sub

Private Sub windowsForm_QueryAccessibilityHelp(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.QueryAccessibilityHelpEventArgs)
  ' Late bind to members of QueryAccessibilityHelpEventArgs
  Dim o As Object
  Set o = e
  AddMessage "QueryAccessibilityHelp", Time & ", Keyword = " & _
  o.HelpKeyword & ", Namespace = " & o.HelpNamespace & ", String = " _
  & o.HelpString
End Sub

Private Sub windowsForm_QueryContinueDrag(ByVal sender As Variant, _
ByVal e As System_Windows_Forms.QueryContinueDragEventArgs)
  ' Late bind to members of QueryContinueDragEventArgs
  Dim o As Object
  Set o = e
  AddMessage "QueryContinueDrag", Time & ", KeyState = " & o.KeyState & _
    ", Escape Pressed = " & o.EscapePressed & _
    ", Action = " & o.Action
End Sub

Private Sub windowsForm_Resize(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Resize", Time
End Sub

Private Sub windowsForm_RightToLeftChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "RightToLeftChanged", Time
End Sub

Private Sub windowsForm_SizeChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "SizeChanged", Time
End Sub

Private Sub windowsForm_StyleChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "StyleChanged", Time
End Sub

Private Sub windowsForm_SystemColorsChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "SystemColorsChanged", Time
End Sub

Private Sub windowsForm_TabIndexChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "TabIndexChanged", Time
End Sub

Private Sub windowsForm_TabStopChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "TabStopChanged", Time
End Sub

Private Sub windowsForm_TextChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "TextChanged", Time
End Sub

Private Sub windowsForm_Validated(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "Validated", Time
End Sub

Private Sub windowsForm_Validating(ByVal sender As Variant, _
cancel As Boolean)
  AddMessage "Validating", Time
End Sub

Private Sub windowsForm_VisibleChanged(ByVal sender As Variant, _
ByVal e As mscorlib.EventArgs)
  AddMessage "VisibleChanged", Time
End Sub
