' To compile:
' vbc /t:library Listing13_3vb.vb

Imports System
Imports System.Runtime.InteropServices

' Source interface with "event handlers" for COM objects to implement
<InterfaceType(ComInterfaceType.InterfaceIsIDispatch)> _
Public Interface IPhoneEvents
  <DispId(1)> _
  Sub Ring()
  <DispId(2)> _
  Sub CallerId(callerName As String, callerPhoneNumber As String)
End Interface

' Delegates for the events
Public Delegate Sub RingEventHandler()
Public Delegate Sub CallerIdEventHandler(callerName As String, callerPhoneNumber As String)

<ComSourceInterfaces(GetType(IPhoneEvents))> _
Public Class Phone

  Public Event Ring As RingEventHandler
  Public Event CallerId As CallerIdEventHandler

  ' More methods to communicate with hardware and raise the events...

End Class
