// FileWriter.h : Declaration of the CFileWriter class

#ifndef __FILEWRITER_H_
#define __FILEWRITER_H_

#include "resource.h"

// Note: Make sure path is appropriate for your computer:
#import "c:\\Windows\\Microsoft.NET\\Framework\\v1.0.3705\\mscorlib.tlb" raw_interfaces_only, raw_native_types, no_namespace, named_guids rename("_Module", "_ReflectionModule")

/////////////////////////////////////////////////////////////////////////////
// CFileWriter
class ATL_NO_VTABLE CFileWriter : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CFileWriter, &CLSID_FileWriter>,
	public ISupportErrorInfo,
	public IDispatchImpl<IFileWriter, &IID_IFileWriter, &LIBID_FILECOMPONENTLib>,
	public IDispatchImpl<IDisposable, &IID_IDisposable, &LIBID_mscorlib>
{
public:
	CFileWriter();
	~CFileWriter();

DECLARE_REGISTRY_RESOURCEID(IDR_FILEWRITER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CFileWriter)
	COM_INTERFACE_ENTRY(IFileWriter)
//DEL 	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY2(IDispatch, IFileWriter)
	COM_INTERFACE_ENTRY(IDisposable)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);
// IFileWriter
	STDMETHOD(WriteLine)(/*[in]*/ BSTR message);
// IDisposable
	STDMETHOD(Dispose)();

private:
	FILE* filePointer;
};

#endif //__FILEWRITER_H_
