Imports System
Imports System.Text
Imports System.Runtime.InteropServices
Imports Microsoft.VisualBasic

Public Class ErrorHelper
  Private Shared FORMAT_MESSAGE_FROM_SYSTEM As Integer = &H1000
  Private Shared LANG_NEUTRAL As Short = &H0
  Private Shared SUBLANG_DEFAULT As Short = &H1
   
  Declare Auto Function FormatMessage Lib "kernel32.dll" _
  (dwFlags As Integer, lpSource As IntPtr, dwMessageId As Integer, dwLanguageId As Integer, <Out> lpBuffer As StringBuilder, nSize As Integer, Arguments As IntPtr) As Integer
  
  Shared Function MakeLangId(p As Short, s As Short) As Integer
    Return (s * Math.Pow(2,10)) Or p
  End Function
    
  Public Shared Function GetErrorMessage(errorCode As Integer) As String
    Dim sb As New StringBuilder(1024)
      
    If FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM, IntPtr.Zero, errorCode, MakeLangId(LANG_NEUTRAL, SUBLANG_DEFAULT), sb, sb.Capacity, IntPtr.Zero) <> 0 Then
      GetErrorMessage = sb.ToString()
    Else
      GetErrorMessage = "<Unrecognized error>"
    End If
  End Function
End Class