' To compile:
' vbc Listing19_5vb.vb

Imports System
Imports System.Runtime.InteropServices
Imports Microsoft.VisualBasic

<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
Structure OSVERSIONINFO_1
  Friend dwOSVersionInfoSize As Integer
  Friend dwMajorVersion As Integer
  Friend dwMinorVersion As Integer
  Friend dwBuildNumber As Integer
  Friend dwPlatformId As Integer
  <MarshalAs(UnmanagedType.ByValTStr, SizeConst:=128)> Friend szCSDVersion As String
End Structure

<StructLayout(LayoutKind.Sequential, CharSet:=CharSet.Auto)> _
Structure OSVERSIONINFO_2
  Friend dwOSVersionInfoSize As Integer
  Friend dwMajorVersion As Integer
  Friend dwMinorVersion As Integer
  Friend dwBuildNumber As Integer
  Friend dwPlatformId As Integer
  <MarshalAs(UnmanagedType.ByValArray, SizeConst:=128)> Friend szCSDVersion() As Char
End Structure

Module GetWindowsVersion
   
  Overloads Declare Auto Function GetVersionEx Lib "kernel32.dll" (ByRef lpVersionInfo As OSVERSIONINFO_1) As Boolean
  
  Overloads Declare Auto Function GetVersionEx Lib "kernel32.dll" (ByRef lpVersionInfo As OSVERSIONINFO_2) As Boolean
      
  Public Sub Main()
    Dim os1 As New OSVERSIONINFO_1()
    os1.dwOSVersionInfoSize = Marshal.SizeOf(os1)
    os1.szCSDVersion = New String(" "c, 128)
  
    If GetVersionEx(os1) Then
      Console.WriteLine("String returned: '" & os1.szCSDVersion & "'")
    End If
      
    Dim os2 As New OSVERSIONINFO_2()
    os2.dwOSVersionInfoSize = Marshal.SizeOf(os2)
    os2.szCSDVersion = New Char(128){}

    If GetVersionEx(os2) Then
      Dim desiredString As String = New String(os2.szCSDVersion).Trim(ControlChars.NullChar)
      Console.WriteLine("String returned: '" & desiredString & "'")
    End If
  End Sub
End Module