// To compile:
// csc /t:library Listing21_24.cs Listing21_21.cs

using System.Runtime.InteropServices;
using System.Runtime.CompilerServices;

[
  ComImport, 
  Guid("3E9BAF2D-7A79-11D2-9334-0000F875AE17"),
  TypeLibType(TypeLibTypeFlags.FCanCreate),
  ComSourceInterfaces(typeof(_INetMeetingEvents)),
  ClassInterface(ClassInterfaceType.None)
]
public class NetMeetingClass : NetMeeting, INetMeeting,
  _INetMeetingEvents_Event
{
  [DispId(100), MethodImpl(MethodImplOptions.InternalCall,
    MethodCodeType=MethodCodeType.Runtime)]
  extern int INetMeeting.Version();

  [DispId(101), MethodImpl(MethodImplOptions.InternalCall,
    MethodCodeType=MethodCodeType.Runtime)]
  extern void INetMeeting.UnDock();

  [DispId(102), MethodImpl(MethodImplOptions.InternalCall,
    MethodCodeType=MethodCodeType.Runtime)]
  [return: MarshalAs(UnmanagedType.Bool)]
  extern bool INetMeeting.IsInConference();

  [DispId(103), MethodImpl(MethodImplOptions.InternalCall,
    MethodCodeType=MethodCodeType.Runtime)]
  extern void INetMeeting.CallTo(string strCallToString);

  [DispId(104), MethodImpl(MethodImplOptions.InternalCall,
    MethodCodeType=MethodCodeType.Runtime)]
  extern void INetMeeting.LeaveConference();

  extern event _INetMeetingEvents_ConferenceEndedEventHandler
    _INetMeetingEvents_Event.ConferenceEnded
  {
    [MethodImpl(MethodImplOptions.InternalCall,
      MethodCodeType=MethodCodeType.Runtime)]
    add {}

    [MethodImpl(MethodImplOptions.InternalCall,
      MethodCodeType=MethodCodeType.Runtime)]
    remove {}
  }

  extern event _INetMeetingEvents_ConferenceStartedEventHandler 
    _INetMeetingEvents_Event.ConferenceStarted
  {
    [MethodImpl(MethodImplOptions.InternalCall,
      MethodCodeType=MethodCodeType.Runtime)]
    add {}

    [MethodImpl(MethodImplOptions.InternalCall,
      MethodCodeType=MethodCodeType.Runtime)]
    remove {}
  }
}