using System;
using System.Runtime.InteropServices;
using Win32;

public class EmailAttack
{
  static WndProcDelegate d;

  // The entry point.  Initializes and runs the game.
  public static void Main()
  {
    Msg msg;                // Windows message
    long currentTime;       // Current time
    int timeBetweenFrames;  // Number of milliseconds between frames
    bool useBetterTimer;    // True if system has a performance counter
    long timeForNextFrame;  // Time to render the next frame

    // Create and register a window class
    WndClassEx wc = new WndClassEx();
    d = new WndProcDelegate(WndProc);

    wc.cbSize = Marshal.SizeOf(typeof(WndClassEx));
    wc.style = ClassStyles.CS_HREDRAW | ClassStyles.CS_VREDRAW;
    wc.lpfnWndProc = d;
    wc.cbClsExtra = 0;
    wc.hInstance = Kernel32.GetModuleHandle(null);
    wc.hIcon = IntPtr.Zero;
    wc.hCursor = User32.LoadCursor(IntPtr.Zero, User32.IDC_ARROW);
    wc.hbrBackground = Gdi32.GetStockObject(Gdi32.BLACK_BRUSH);
    wc.lpszMenuName = null;
    wc.lpszClassName = "E-mail Attack";

    if (User32.RegisterClassEx(ref wc) == IntPtr.Zero)
    {
      throw new ApplicationException(
        "Fatal error.  Unable to register the window class.");
    }

    // Create the window and display it
    IntPtr hWnd = User32.CreateWindowEx(0,                // extra style
        "E-mail Attack",                                  // class name
        "E-mail Attack",                                  // window name
        WindowStyles.WS_VISIBLE | WindowStyles.WS_POPUP,  // style
        0,                                                // left
        0,                                                // top
        User32.GetSystemMetrics(User32.SM_CXSCREEN),      // width
        User32.GetSystemMetrics(User32.SM_CYSCREEN),      // height
        IntPtr.Zero,                                      // parent window
        IntPtr.Zero,                                      // menu
        wc.hInstance,                                     // instance
        IntPtr.Zero);                                     // param

    if (hWnd == IntPtr.Zero)
      throw new ApplicationException(
        "Fatal error.  Unable to create the window.");

    User32.ShowWindow(hWnd, WindowState.SW_SHOWDEFAULT);
    User32.UpdateWindow(hWnd);
    User32.ShowCursor(false);

    // Use a performance counter for higher precision timing, if available
    long frequency;
    if (Kernel32.QueryPerformanceFrequency(out frequency))
    {
      Kernel32.QueryPerformanceCounter(out timeForNextFrame);
      // Make the time between frames approx. 16 milliseconds.
      timeBetweenFrames = (int)(frequency / 60);
      useBetterTimer = true;
    }
    else
    {
      timeForNextFrame = WinMM.timeGetTime();
      timeBetweenFrames = 16;
      useBetterTimer = false;
    }

    using (Game game = new Game(hWnd))
    {
      // Windows message loop
      msg = new Msg();
      while(msg.message != Messages.WM_QUIT)
      {
        if (User32.PeekMessage(
          out msg, IntPtr.Zero, 0, 0, PeekMessages.PM_REMOVE))
        {
          User32.TranslateMessage(ref msg);
          User32.DispatchMessage(ref msg);
        }
        else
        {
          if (useBetterTimer)
            Kernel32.QueryPerformanceCounter(out currentTime);
          else
            currentTime = WinMM.timeGetTime();

          if (currentTime > timeForNextFrame)
          {
            // Update the global counter.
            Util.Counter = (Util.Counter + 1) % 30000;

             Game.Render();

             // Check to see if the player died by
             // going off the left edge of the screen
             // or staying on an envelope that disappeared.
             if (Game.State == GameStates.Running)
             {
               Game.CheckForDeath();
             }

             // Set the time for the next frame
             timeForNextFrame = currentTime + timeBetweenFrames;
          }
        }
      }
    }
  }

  // Handles the Windows messages
  private static int WndProc(
    IntPtr hWnd, Messages msg, int wParam, int lParam)
  {
    switch (msg)
    {
      case Messages.WM_DESTROY:
        User32.PostQuitMessage(0);
        return 0;
      case Messages.WM_KEYDOWN:
        if (Game.State == GameStates.Running)
        {
          // Pressing escape exits the game, pressing pause
          // pauses it, and pressing one of the arrow keys
          // moves the player
          switch ((Keys)wParam)
          {
            case Keys.VK_DOWN:
              Game.MovePlayer(Moves.Down);
              break;
            case Keys.VK_UP:
              Game.MovePlayer(Moves.Up);
              break;
            case Keys.VK_LEFT:
              Game.MovePlayer(Moves.Left);
              break;
            case Keys.VK_RIGHT:
              Game.MovePlayer(Moves.Right);
              break;
            case Keys.VK_ESCAPE:
              User32.DestroyWindow(hWnd);
              return 0;
            case Keys.VK_PAUSE:
              Game.State = GameStates.Paused;
              break;
            default:
              break;
          }
        }
        else
        {
          // Pressing escape exits the game, and pressing
          // any other key starts it
          switch ((Keys)wParam)
          {
            case Keys.VK_ESCAPE:
              User32.DestroyWindow(hWnd);
              return 0;
            default:
              Game.State = GameStates.Running;
              break;
          }
        }
        break;
      default:
        break;
    }
    return User32.DefWindowProc(hWnd, msg, wParam, lParam);
  }
}