// The 4 different states during game execution
public enum GameStates
{
  Paused,     // The paused screen is displayed
  Running,    // The game is being played
  NotStarted, // The title screen is displayed
  TryAgain    // The screen shown in-between lives is displayed
}

// The 4 valid player moves
public enum Moves
{
  Up,
  Down,
  Left,
  Right
}