// WARNING: This code doesn't compile as-is.  
// It must be used with a specific COM component, and "SomeComLibrary", "SomeComObject", "SomeString", and "SomeMethod"
// must be changed appropriately.

using SomeComLibrary;
using System.Reflection;

public class LateBinding
{
  public static void Main()
  {
    SomeComObject obj = new SomeComObject();

    object [] args = { "SomeString" };

    // Initialize a ParameterModifier with the number of parameters
    ParameterModifier p = new ParameterModifier(1);
    // Set the VT_BYREF flag on the first parameter
    p[0] = true;
    // Always create an array of ParameterModifiers with a single element
    ParameterModifier [] mods = { p };

    // Call the method via late binding. 
    // The parameter is passed by reference (VT_BSTR | VT_BYREF)
    obj.GetType().InvokeMember("SomeMethod", BindingFlags.InvokeMethod, null,
      obj, args, mods, null, null);

    // Call the method again using the simplest InvokeMember overload
    // The parameter is passed by value (VT_BSTR) 
    obj.GetType().InvokeMember("SomeMethod", BindingFlags.InvokeMethod, null,
      obj, args);
  }
}