' Simple Web Browser - see Chapter 5 for a more complete browser that uses events.
' Before compiling, run AXIMP on shdocvw.dll to create AxSHDocVw.dll and SHDocVw.dll.  Then run:
' vbc MyWebBrowser.vb /r:System.Windows.Forms.dll /r:System.Drawing.dll /r:System.dll /r:SHDocVw.dll /r:AxSHDocVw.dll /res:MyWebBrowser.resources

Imports System
Imports SHDocVw
Imports System.Windows.Forms
Imports System.Reflection

Public Class MyWebBrowser
  Inherits Form

  Private components As System.ComponentModel.IContainer
  Private statusBar1 As System.Windows.Forms.StatusBar
  Private WithEvents toolBar1 As System.Windows.Forms.ToolBar
  Private backButton As System.Windows.Forms.ToolBarButton
  Private forwardButton As System.Windows.Forms.ToolBarButton
  Private stopButton As System.Windows.Forms.ToolBarButton
  Private panel1 As System.Windows.Forms.Panel
  Private axWebBrowser1 As AxSHDocVw.AxWebBrowser
  Private WithEvents goButton As System.Windows.Forms.Button
  Private navigateBox As System.Windows.Forms.TextBox
  Private imageList1 As System.Windows.Forms.ImageList
  Private refreshButton As System.Windows.Forms.ToolBarButton
  Private homeButton As System.Windows.Forms.ToolBarButton
  Private label1 As System.Windows.Forms.Label
   
  Public Sub New()
    ' Required for Windows Form Designer support
    InitializeComponent()
    axWebBrowser1.GoHome()
  End Sub

  ' Clean up any resources being used
  Protected Overrides Overloads Sub Dispose(disposing As Boolean)
    If disposing Then
      If Not (components Is Nothing) Then
        components.Dispose()
      End If
    End If
    MyBase.Dispose(disposing)
  End Sub

  ' Required method for Designer support
  Private Sub InitializeComponent()
    Me.components = New System.ComponentModel.Container()
    Dim resources As New System.Resources.ResourceManager(GetType(MyWebBrowser))
    Me.statusBar1 = New System.Windows.Forms.StatusBar()
    Me.toolBar1 = New System.Windows.Forms.ToolBar()
    Me.backButton = New System.Windows.Forms.ToolBarButton()
    Me.forwardButton = New System.Windows.Forms.ToolBarButton()
    Me.stopButton = New System.Windows.Forms.ToolBarButton()
    Me.refreshButton = New System.Windows.Forms.ToolBarButton()
    Me.homeButton = New System.Windows.Forms.ToolBarButton()
    Me.imageList1 = New System.Windows.Forms.ImageList(Me.components)
    Me.goButton = New System.Windows.Forms.Button()
    Me.panel1 = New System.Windows.Forms.Panel()
    Me.axWebBrowser1 = New AxSHDocVw.AxWebBrowser()
    Me.navigateBox = New System.Windows.Forms.TextBox()
    Me.label1 = New System.Windows.Forms.Label()
    Me.panel1.SuspendLayout()
    CType(Me.axWebBrowser1, System.ComponentModel.ISupportInitialize).BeginInit()
    Me.SuspendLayout()
    ' 
    ' statusBar1
    ' 
    Me.statusBar1.Location = New System.Drawing.Point(0, 437)
    Me.statusBar1.Name = "statusBar1"
    Me.statusBar1.RightToLeft = System.Windows.Forms.RightToLeft.Yes
    Me.statusBar1.Size = New System.Drawing.Size(528, 16)
    Me.statusBar1.TabIndex = 2
    ' 
    ' toolBar1
    ' 
    Me.toolBar1.AutoSize = False
    Me.toolBar1.Buttons.AddRange(New System.Windows.Forms.ToolBarButton() {Me.backButton, Me.forwardButton, Me.stopButton, Me.refreshButton, Me.homeButton})
    Me.toolBar1.ButtonSize = New System.Drawing.Size(80, 23)
    Me.toolBar1.Divider = False
    Me.toolBar1.DropDownArrows = True
    Me.toolBar1.ImageList = Me.imageList1
    Me.toolBar1.Name = "toolBar1"
    Me.toolBar1.ShowToolTips = True
    Me.toolBar1.Size = New System.Drawing.Size(528, 28)
    Me.toolBar1.TabIndex = 3
    Me.toolBar1.TextAlign = System.Windows.Forms.ToolBarTextAlign.Right
    ' 
    ' backButton
    ' 
    Me.backButton.ImageIndex = 0
    Me.backButton.Text = "Back"
    ' 
    ' forwardButton
    ' 
    Me.forwardButton.ImageIndex = 1
    Me.forwardButton.Text = "Forward"
    ' 
    ' stopButton
    ' 
    Me.stopButton.ImageIndex = 2
    Me.stopButton.Text = "Stop"
    ' 
    ' refreshButton
    ' 
    Me.refreshButton.ImageIndex = 3
    Me.refreshButton.Text = "Refresh"
    ' 
    ' homeButton
    ' 
    Me.homeButton.ImageIndex = 4
    Me.homeButton.Text = "Home"
    ' 
    ' imageList1
    ' 
    Me.imageList1.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit
    Me.imageList1.ImageSize = New System.Drawing.Size(16, 16)
    Me.imageList1.ImageStream = CType(resources.GetObject("imageList1.ImageStream"), System.Windows.Forms.ImageListStreamer)
    Me.imageList1.TransparentColor = System.Drawing.Color.Magenta
    ' 
    ' goButton
    ' 
    Me.goButton.Anchor = System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Right
    Me.goButton.Location = New System.Drawing.Point(469, 32)
    Me.goButton.Name = "goButton"
    Me.goButton.Size = New System.Drawing.Size(56, 20)
    Me.goButton.TabIndex = 6
    Me.goButton.Text = "Go"
    ' 
    ' panel1
    ' 
    Me.panel1.Anchor = System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom Or System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right
    Me.panel1.Controls.AddRange(New System.Windows.Forms.Control() {Me.axWebBrowser1})
    Me.panel1.Location = New System.Drawing.Point(0, 58)
    Me.panel1.Name = "panel1"
    Me.panel1.Size = New System.Drawing.Size(528, 382)
    Me.panel1.TabIndex = 9
    ' 
    ' axWebBrowser1
    ' 
    Me.axWebBrowser1.ContainingControl = Me
    Me.axWebBrowser1.Dock = System.Windows.Forms.DockStyle.Fill
    Me.axWebBrowser1.Enabled = True
    Me.axWebBrowser1.OcxState = CType(resources.GetObject("axWebBrowser1.OcxState"), System.Windows.Forms.AxHost.State)
    Me.axWebBrowser1.Size = New System.Drawing.Size(528, 382)
    Me.axWebBrowser1.TabIndex = 0
    ' 
    ' navigateBox
    ' 
    Me.navigateBox.Anchor = System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Left Or System.Windows.Forms.AnchorStyles.Right
    Me.navigateBox.Location = New System.Drawing.Point(56, 32)
    Me.navigateBox.Name = "navigateBox"
    Me.navigateBox.Size = New System.Drawing.Size(408, 20)
    Me.navigateBox.TabIndex = 12
    Me.navigateBox.Text = ""
    ' 
    ' label1
    ' 
    Me.label1.Location = New System.Drawing.Point(8, 35)
    Me.label1.Name = "label1"
    Me.label1.Size = New System.Drawing.Size(48, 16)
    Me.label1.TabIndex = 13
    Me.label1.Text = "Address"
    ' 
    ' MyWebBrowser
    ' 
    Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
    Me.ClientSize = New System.Drawing.Size(528, 453)
    Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.label1, Me.toolBar1, Me.navigateBox, Me.panel1, Me.goButton, Me.statusBar1})
    Me.Name = "MyWebBrowser"
    Me.Text = "Web Browser"
    Me.panel1.ResumeLayout(False)
    CType(Me.axWebBrowser1, System.ComponentModel.ISupportInitialize).EndInit()
    Me.ResumeLayout(False)
  End Sub

  Shared Sub Main()
    Application.Run(New MyWebBrowser())
  End Sub
   
  ' Called when one of the toolbar buttons is clicked
  Private Sub toolBar1_ButtonClick(sender As Object, e As ToolBarButtonClickEventArgs) Handles toolBar1.ButtonClick
    If e.Button.Text = "Back" Then
      Try
        axWebBrowser1.GoBack()
      Catch 
      End Try
    ElseIf e.Button.Text = "Forward" Then
      Try
        axWebBrowser1.GoForward()
      Catch 
      End Try
    ElseIf e.Button.Text = "Stop" Then
      axWebBrowser1.Stop()
    ElseIf e.Button.Text = "Refresh" Then
      axWebBrowser1.CtlRefresh()
    ElseIf e.Button.Text = "Home" Then
      axWebBrowser1.GoHome()
    End If
  End Sub
   
  ' Called when "Go" is clicked
  Private Sub goButton_Click(sender As Object, e As System.EventArgs) Handles goButton.Click
    axWebBrowser1.Navigate(navigateBox.Text)
  End Sub

End Class