' To compile:
' vbc Listing5_3.vb /r:System.Windows.Forms.dll

Imports System

' The delegates
Public Delegate Sub DisplayMessage(ByVal text As String)
Public Delegate Sub UserJoined(ByVal user As String)
Public Delegate Sub UserLeft(ByVal user As String)

Public Class Display
  Public Sub ConsoleMessage(ByVal text As String)
    Console.WriteLine("MESSAGE: " & text)
  End Sub

  Public Sub AnnoyingMessage(ByVal text As String)
    System.Windows.Forms.MessageBox.Show("MESSAGE: " & text)
  End Sub
End Class

Module ChatRoomClient
  Sub Main()
    Dim display As New Display()
    Dim server As New ChatRoomServer()
    Dim one As DisplayMessage = AddressOf display.ConsoleMessage
    Dim two As DisplayMessage = AddressOf display.AnnoyingMessage
    Dim both As DisplayMessage = both.Combine(one, two)
    '...
    server.Run(both)
    '...
  End Sub
End Module

Public Class ChatRoomServer
  Public Sub Run(ByVal display As DisplayMessage)
    '...
    ' The callback
    If (Not display Is Nothing) Then display("text")
    '...
  End Sub
End Class