' To compile:
' vbc Listing5_6.vb /r:System.Windows.Forms.dll

Imports System

Module ChatRoomClient
  Dim WithEvents server As New ChatRoomServer()

  Sub Main()
    '...
    server.Run()
    '...
  End Sub

  Public Sub ConsoleMessage(ByVal text As String) _
    Handles server.DisplayMessage
    Console.WriteLine("MESSAGE: " & text)
  End Sub

  Public Sub AnnoyingMessage(ByVal text As String) _
    Handles server.DisplayMessage
    System.Windows.Forms.MessageBox.Show("MESSAGE: " & text)
  End Sub
End Module

Public Class ChatRoomServer
  Public Event DisplayMessage(ByVal text As String)
  Public Event UserJoined(ByVal user As String)
  Public Event UserLeft(ByVal user As String)

  Public Sub Run()
    '...
    ' The callback
    RaiseEvent DisplayMessage("text")
    '...
  End Sub
End Class