// To compile, first obtain an Interop Assembly for PowerPoint 2002.  If a PIA is not yet
// available, run TLBIMP on msppt.olb.  Then run:
// csc Listing6_5cs.cs /r:PowerPoint.dll /r:Office.dll

using System;
using PowerPoint;
using Microsoft.Office.Core;
using System.Runtime.CompilerServices;

public class Client
{
  [MethodImpl(MethodImplOptions.NoInlining)]
  public static void DoWorkWithPowerPoint()
  {
    Application app = new Application();
    Presentations pres = app.Presentations;
    app.Visible = MsoTriState.msoTrue;
    app.Quit();
  }

  public static void Main()
  {
    DoWorkWithPowerPoint();

    // The app and pres instances will now be collected
    GC.Collect();
    GC.WaitForPendingFinalizers();

    Console.WriteLine("Press Enter to exit...");
    Console.ReadLine();
  }
}