' To compile, first obtain an Interop Assembly for PowerPoint 2002.  If a PIA is not yet
' available, run TLBIMP on msppt.olb.  Then run:
' vbc Listing6_5vb.vb /r:PowerPoint.dll /r:Office.dll

Imports System
Imports PowerPoint
Imports Microsoft.Office.Core
Imports System.Runtime.CompilerServices

Public Class Client
  <MethodImpl(MethodImplOptions.NoInlining)> _
  Public Shared Sub DoWorkWithPowerPoint()
    Dim app As Application = new Application()
    Dim pres As Presentations = app.Presentations
    app.Visible = MsoTriState.msoTrue
    app.Quit()
  End Sub

  Public Shared Sub Main()

    DoWorkWithPowerPoint()

    ' The app and pres instances will now be collected
    GC.Collect()
    GC.WaitForPendingFinalizers()

    Console.WriteLine("Press Enter to exit...")
    Console.ReadLine()
  End Sub
End Class