' To compile:
' vbc /t:library IdlCustomAttribute.vb

Imports System

<AttributeUsage(AttributeTargets.All)> _
Public Class IdlCustomAttribute
  Inherits Attribute
  Private _value As Object
  Private _guid As Guid
   
  Public Sub New(guid As Guid, value As Object)
    _guid = guid
    _value = value
  End Sub
   
  Public ReadOnly Property Value() As Object
    Get
      Return _value
    End Get
  End Property
   
  Public ReadOnly Property Name() As Guid
    Get
      Return _guid
    End Get
  End Property
End Class