// To compile, do the following on a computer with Office XP,
// adjusting the path as appropriate:
//
// tlbimp "c:\Program Files\Microsoft Office\Office10\MSWORD.OLB"
// csc Listing7_4originalcs.cs /r:Word.dll
//
// If a Primary Interop Assembly exists for Word, 
// you should use it instead of running TLBIMP.EXE.

using System;

public class UseWord
{
  public static void Main()
  {
    object missing = Type.Missing;

    try
    {
      Word.Application msWord = new Word.Application();
      Word._Document doc = msWord.Documents.Add(ref missing, ref missing,
        ref missing, ref missing);

      Console.WriteLine("Added the document '" + doc.FullName + "'.");

      msWord.Quit(ref missing, ref missing, ref missing);
    }
    catch (Exception ex)
    {
      Console.WriteLine("Unexpected error: " + ex.ToString());
    }
  }
}