// To compile:
// csc /t:library EnumerableObject.cs

using System.Collections;
using System.Runtime.InteropServices;

public class EnumerableObject : IEnumerable
{
  private Hashtable table = null;

  //...

  // Explicitly-implemented GetEnumerator
  IEnumerator IEnumerable.GetEnumerator()
  {
    return table.Values.GetEnumerator();
  }

  // Strongly-typed GetEnumerator
  [DispId(-4)]
  public IDictionaryEnumerator GetEnumerator()
  {
    return table.GetEnumerator();
  }
}