' To compile:
' vbc /t:library EnumerableObject.vb

Imports System.Collections
Imports System.Runtime.InteropServices

Public Class EnumerableObject
  Implements IEnumerable

  Private table As Hashtable = Nothing
   
  '...

  ' Explicitly-implemented GetEnumerator
  Function IEnumerable_GetEnumerator() As IEnumerator Implements IEnumerable.GetEnumerator
    IEnumerable_GetEnumerator = table.Values.GetEnumerator()
  End Function
   
  ' Strongly-typed GetEnumerator
  <DispId(-4)> _
  Public Function GetEnumerator() As IDictionaryEnumerator
    GetEnumerator = table.GetEnumerator()
  End Function

End Class