// This is incorrect code, just for demonstration.
// MarshalAsAttribute should be used consistently, and auto-dual class interfaces should be avoided.

// To compile:
// csc /t:library Listing12_1cs.cs
 
using System;
using System.Runtime.InteropServices;

[assembly:ClassInterface(ClassInterfaceType.AutoDual)]

public interface IDonate
{
  void GiveMoney([MarshalAs(UnmanagedType.Currency)] Decimal amount);
}

public class Philanthropist : IDonate
{
  // UnmanagedType.Currency is omitted for demonstration
  public virtual void GiveMoney(Decimal amount) { }
}

public class Humanitarian : Philanthropist
{
  public override void GiveMoney(
    [MarshalAs(UnmanagedType.Currency)] Decimal amount) { }
}