// To compile:
// csc /t:library Listing12_6cs.cs

using System;
using System.Runtime.InteropServices;

public class MyVisualization
{
  [ComRegisterFunction]
  private static void ComRegisterFunction(Type t)
  {
    Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.LocalMachine;
    key = key.CreateSubKey("Software\\Microsoft\\MediaPlayer\\" +
      "Objects\\Effects\\Visualization Sample\\Properties");
    key.SetValue("classid", t.GUID.ToString("B"));
    key.SetValue("name", "Visualization Sample");
    key.SetValue("description", 
      "This collection includes a visualization written in C#.");
    key.Close();
  }

  [ComUnregisterFunction]
  private static void ComUnregisterFunction(Type t)
  {
    Microsoft.Win32.RegistryKey key = Microsoft.Win32.Registry.LocalMachine;
    key.DeleteSubKey("Software\\Microsoft\\MediaPlayer\\" +
      "Objects\\Effects\\Visualization Sample\\Properties", false);
    key.DeleteSubKey("Software\\Microsoft\\MediaPlayer\\" +
      "Objects\\Effects\\Visualization Sample", false);
  }

  //...
}