' To compile:
' vbc /t:library ServerOptional.vb
'
' Then, this can be used with ClientOptional.

Imports System
Imports System.Runtime.InteropServices

Public Class UsingOptional

  ' Although Visual Basic .NET supports optional parameters without
  ' the use of custom attributes, using System.Runtime.InteropServices.OptionalAttribute
  ' enables us to bypass the compiler rule that optional parameters must specify 
  ' a default value

  ' Square brackets are used since "Optional" is a keyword

  Public Sub HasOptional(<[Optional]> x As Integer, <[Optional]> y As Object)
    Console.WriteLine("x = " & x)
    Console.WriteLine("y = " & y.ToString())
  End Sub

End Class