// To compile:
// csc /t:library Phone.cs

// Delegates for the events
public delegate void RingEventHandler();
public delegate void CallerIdEventHandler(string callerName, 
  byte [] callerPhoneNumber);

public class Phone
{
  // The two events
  public event RingEventHandler Ring;
  public event CallerIdEventHandler CallerId;
  //...
}