// To compile:
// csc /t:library IMarshal.cs

using System;
using System.Runtime.InteropServices;

[
  ComImport,
  Guid("00000003-0000-0000-C000-000000000046"), 
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
]
interface IMarshal
{
  Guid GetUnmarshalClass([In] ref Guid iid, 
    [MarshalAs(UnmanagedType.Interface)] Object pvInterface, 
    int dwDestContext, IntPtr pvDestContext, int mshlflags);
  uint GetMarshalSizeMax([In] ref Guid iid, 
    [MarshalAs(UnmanagedType.Interface)] Object pvInterface, 
    int dwDestContext, IntPtr pvDestContext, int mshlflags);
  void MarshalInterface(UCOMIStream pstm, [In] ref Guid iid, 
    [MarshalAs(UnmanagedType.Interface)] Object pvInterface, 
    int dwDestContext, IntPtr pvDestContext, int mshlflags);
  [return:MarshalAs(UnmanagedType.Interface)]
  Object UnmarshalInterface(UCOMIStream pstm, [In] ref Guid iid);
  void ReleaseMarshalData(UCOMIStream pstm);
  void DisconnectObject(int dwReserved);
}