// To compile:
// csc /t:library IObjectSafety.cs

using System;
using System.Runtime.InteropServices;

[
  ComImport,
  Guid("CB5BDC81-93C1-11CF-8F20-00805F2CD064"),
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
]
interface IObjectSafety
{
  void GetInterfaceSafetyOptions([In] ref Guid riid,
    out uint pdwSupportedOptions,
    out uint pdwEnabledOptions);

  void SetInterfaceSafetyOptions([In] ref Guid riid,
    uint dwOptionSetMask,
    uint dwEnabledOptions);
}