#define _WIN32_DCOM
#include <wtypes.h>

HRESULT ReturnError()
{
	ICreateErrorInfo *pcerrinfo;
	IErrorInfo *perrinfo;
	HRESULT hr;

	BSTR description = SysAllocString(
	L"The name 'Sue' does not match any existing records.");
	BSTR helpfile = SysAllocString(L"http://www.samspublishing.com/help.html");
	long helpcontext = 44444;
	BSTR source = SysAllocString(L"My Component");

	hr = CreateErrorInfo(&pcerrinfo);
	if (SUCCEEDED(hr))
	{
	pcerrinfo->SetDescription(description);
	pcerrinfo->SetHelpFile(helpfile);
	pcerrinfo->SetHelpContext(helpcontext);
	pcerrinfo->SetSource(source);

	hr = pcerrinfo->QueryInterface(IID_IErrorInfo, (void**)&perrinfo);
	if (SUCCEEDED(hr))
	{
		SetErrorInfo(0, perrinfo);
		perrinfo->Release();
	}
	   
	pcerrinfo->Release();
	}

	return 0x800A1608;
}