// To compile, first run "tlbimp FileComponent.dll" to create FILECOMPONENTLib.dll.
// Then run:
// csc FileWriterClient.cs /r:FILECOMPONENTLib.dll

using System;
using FILECOMPONENTLib;

public class Client
{
  public static void Main()
  {
    using (FileWriterClass f = new FileWriterClass())
    {
      foreach(int i in new int[]{1,2,3,4,5,6,7,8,9,10})
        f.WriteLine(i.ToString());
    }

    using (IDisposable f2 = (IDisposable)new FileWriter())
    {
      foreach(int i in new int[]{1,2,3,4,5,6,7,8,9,10})
        ((FileWriter)f2).WriteLine(i.ToString());
    }

    Console.WriteLine("Contents have been written to the file.");
  }
}