// To compile:
// csc Listing18_4.cs

using System;
using System.Text;
using System.Runtime.InteropServices;

public class DisplayWindowsDirectory
{
  [DllImport("kernel32.dll")]
  static extern int GetWindowsDirectory(StringBuilder lpBuffer, int uSize);

  public static void Main()
  {
    // Pick an arbitrary initial size
    StringBuilder buffer = new StringBuilder(20);

    int returnedSize = GetWindowsDirectory(buffer, buffer.Capacity);

    if (returnedSize <= buffer.Capacity)
    {
      Console.WriteLine("Windows Directory: '" + buffer.ToString() + "'");
    }
    else
    {
      // Try again with the required buffer size
      buffer.Capacity = returnedSize;

      GetWindowsDirectory(buffer, buffer.Capacity);

      Console.WriteLine("Windows Directory: '" + buffer.ToString() + "'");
    }
  }
}