' To compile:
' vbc Listing18_5.vb

Imports System
Imports System.Text
Imports Microsoft.VisualBasic
Imports System.Runtime.InteropServices

Public Module DisplayWindowsDirectory

  Declare Auto Function GetWindowsDirectory Lib "kernel32.dll" _
    (ByVal lpBuffer as String, ByVal uSize As Integer) As Integer

  Public Sub Main()
    ' Pick an arbitrary initial size
    Dim buffer As String = New String(CChar(" "), 20)

    Dim returnedSize As Integer 
    returnedSize = GetWindowsDirectory(buffer, buffer.Length)

    If (returnedSize <= buffer.Length)
      Console.WriteLine("Windows Directory: '" & _
        Left(buffer, returnedSize) & "'")
    Else
      ' Try again with the required buffer size
      buffer = New String(CChar(" "), returnedSize)

      GetWindowsDirectory(buffer, buffer.Length)

      Console.WriteLine("Windows Directory: '" & _
        Left(buffer, returnedSize) + "'")
    End If
  End Sub
End Module