// To compile:
// csc /t:library Listing19_8cs.cs

using System;
using System.Runtime.InteropServices;

internal struct SID1
{
  internal byte Revision;
  internal byte SubAuthorityCount;
  [MarshalAs(UnmanagedType.ByValArray, SizeConst=6)]
  internal byte [] Value;
  [MarshalAs(UnmanagedType.ByValArray, SizeConst=1)]
  internal uint [] SubAuthority;
}

internal struct SID16
{
  internal byte Revision;
  internal byte SubAuthorityCount;
  [MarshalAs(UnmanagedType.ByValArray, SizeConst=6)]
  internal byte [] Value;
  [MarshalAs(UnmanagedType.ByValArray, SizeConst=16)]
  internal uint [] SubAuthority;
}

internal struct SID256
{
  internal byte Revision;
  internal byte SubAuthorityCount;
  [MarshalAs(UnmanagedType.ByValArray, SizeConst=6)]
  internal byte [] Value;
  [MarshalAs(UnmanagedType.ByValArray, SizeConst=256)]
  internal uint [] SubAuthority;
}

public class UsingVariableStructs
{
  [DllImport("advapi32.dll", CharSet=CharSet.Auto)]
  static extern bool ConvertStringSidToSid(string StringSid, 
    out IntPtr Sid);

  //...
}