VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form VB6Form 
   Caption         =   "Visual Basic 6 Form"
   ClientHeight    =   2970
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   2970
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   2640
      Top             =   2160
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton SetFontButton 
      Caption         =   "Set .NET Font"
      Height          =   375
      Left            =   3120
      TabIndex        =   3
      Top             =   2520
      Width           =   1455
   End
   Begin VB.CommandButton ChangeFontButton 
      Caption         =   "Change Font"
      Height          =   375
      Left            =   1800
      TabIndex        =   2
      Top             =   2520
      Width           =   1095
   End
   Begin VB.CommandButton GetFontButton 
      Caption         =   "Get .NET Font"
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   2520
      Width           =   1455
   End
   Begin VB.TextBox Text1 
      Height          =   2415
      Left            =   0
      MultiLine       =   -1  'True
      TabIndex        =   0
      Top             =   0
      Width           =   4695
   End
End
Attribute VB_Name = "VB6Form"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' To run this project, first compile ManagedForm.dll.  After registering ManagedForm and exporting
' a type library, reference ManagedForm.tlb in this project.

Private windowsForm As ManagedForm.ManagedForm

Private Sub Form_Load()
  ' Initialize the text box to a TrueType font
  Text1.FontName = "Arial"
  
  ' Instantiate the Windows Form
  Set windowsForm = New ManagedForm.ManagedForm
  windowsForm.Show
End Sub

' Set the COM font to a custom-marshaled .NET font
Private Sub GetFontButton_Click()
  Dim f As Object
  Set f = windowsForm.TextBoxFont
  Text1.Font.Name = f.Name
  Text1.Font.Size = f.Size
  Text1.Font.Bold = f.Bold
  Text1.Font.Italic = f.Italic
  Text1.Font.Underline = f.Underline
  Text1.Font.Strikethrough = f.Strikethrough
End Sub

' Set the .NET font to a custom-marshaled COM font
Private Sub SetFontButton_Click()
  windowsForm.TextBoxFont = Text1.Font
End Sub

Private Sub ChangeFontButton_Click()
  CommonDialog1.CancelError = True
  On Error GoTo ErrHandler
  ' Show only TrueType fonts
  CommonDialog1.Flags = cdlCFEffects Or cdlCFBoth Or cdlCFTTOnly
  ' Show the current font in the dialog
  CommonDialog1.FontName = Text1.Font.Name
  CommonDialog1.FontSize = Text1.Font.Size
  CommonDialog1.FontBold = Text1.Font.Bold
  CommonDialog1.FontItalic = Text1.Font.Italic
  CommonDialog1.FontUnderline = Text1.Font.Underline
  CommonDialog1.FontStrikethru = Text1.Font.Strikethrough
  CommonDialog1.Color = &H0&
  ' Display the Font dialog box
  CommonDialog1.ShowFont
  Text1.Font.Name = CommonDialog1.FontName
  Text1.Font.Size = CommonDialog1.FontSize
  Text1.Font.Bold = CommonDialog1.FontBold
  Text1.Font.Italic = CommonDialog1.FontItalic
  Text1.Font.Underline = CommonDialog1.FontUnderline
  Text1.Font.Strikethrough = CommonDialog1.FontStrikethru
  If (CommonDialog1.Color <> &H0&) Then
    MsgBox "Ignoring color choice since it is not part of the font.", _
      vbOKOnly, "Color Not Changed"
  End If
  Exit Sub
ErrHandler:
  ' User pressed the Cancel button
End Sub

