// To compile:
// csc /t:library Listing21_13cs.cs

using System;
using System.Runtime.InteropServices;

[
  ComImport,
  Guid("0000010c-0000-0000-C000-000000000046"),
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
]
interface IPersist
{
  void GetClassID(out Guid pClassID);
}

[
  ComImport,
  Guid("00000109-0000-0000-C000-000000000046"),
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
]
interface IPersistStream : IPersist
{
  // IPersist Method
  new void GetClassID(out Guid pClassID);

  // IPersistStream Methods
  [PreserveSig]
  int IsDirty();
  void Load([In] UCOMIStream pStm);
  void Save([In] UCOMIStream pStm, 
    [In, MarshalAs(UnmanagedType.Bool)] bool fClearDirty);
  void GetSizeMax(out long pcbSize);
}