// To compile:
// csc /t:library Listing21_17.cs

using System;
using System.Runtime.InteropServices;

[
  ComImport,
  Guid("0000010c-0000-0000-C000-000000000046"),
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
]
interface IPersist
{
  Guid Clsid { get; }
}

[
  ComImport,
  Guid("00000109-0000-0000-C000-000000000046"),
  InterfaceType(ComInterfaceType.InterfaceIsIUnknown)
]
interface IPersistStream : IPersist
{
  // IPersist Property
  new Guid Clsid { get; }

  // IPersistStream Members
  int IsDirty { [PreserveSig] get; }
  void Load([In] UCOMIStream stream);
  void Save([In] UCOMIStream stream, 
    [In, MarshalAs(UnmanagedType.Bool)] bool clearDirty);
  long MaxSize { get; }
}