// To compile:
// csc /t:library Listing21_23cs.cs

using System.Runtime.InteropServices;

[StructLayout(LayoutKind.Sequential, Pack=4)]
struct RECT 
{
  public int Left;
  public int Top;
  public int Right;
  public int Bottom;
}

[StructLayout(LayoutKind.Sequential)]
struct TimedLevel
{
  [MarshalAs(UnmanagedType.ByValArray, SizeConst=2048)]
  public byte [] frequency;      
  [MarshalAs(UnmanagedType.ByValArray, SizeConst=2048)]
  public byte [] waveform;       
  public int State;
  public long TimeStamp;
}