// To compile:
// csc /t:library Listing21_8.cs /r:CustomMarshalers.dll

using System.Collections;
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Runtime.InteropServices.CustomMarshalers;

[
  ComImport,
  Guid("ab9d3261-d6ea-4fbd-80f6-cf7bad0732f3"),
  TypeLibType(TypeLibTypeFlags.FDual | TypeLibTypeFlags.FDispatchable)
]
interface IRunningAppCollection : IEnumerable
{
  [
    DispId(-4),
    TypeLibFuncAttribute(TypeLibFuncFlags.FRestricted),
    MethodImpl(MethodImplOptions.InternalCall, 
    MethodCodeType=MethodCodeType.Runtime)
  ]
  [return: MarshalAs(UnmanagedType.CustomMarshaler, 
   MarshalTypeRef=typeof(EnumeratorToEnumVariantMarshaler))]
  new IEnumerator GetEnumerator();

  [DispId(1)]
  int Count 
  {
    [MethodImpl(MethodImplOptions.InternalCall, 
     MethodCodeType=MethodCodeType.Runtime)]
     get;
  }

  [DispId(2)]
  object this[int lIndex] 
  {
    [MethodImpl(MethodImplOptions.InternalCall, 
     MethodCodeType=MethodCodeType.Runtime)]
    [return: MarshalAs(UnmanagedType.IDispatch)] get;
  }
}